//
//  DustMite.m
//  Fish
//
//  Created by Daniel Loomb on 23/08/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "AnimalFur.h"
#import "SpitProjectile.h"
#import "DeathSplat.h"

@implementation AnimalFur


Fish *aFish;
NSMutableArray *aTriggerArray;
PreventerWall *theLining;
NSMutableArray *miscUpdateArray;

float animalFur_radius = 30;


-(id) init :(Fish *) passedFish : (PreventerWall *) passedPreventerArray : (NSMutableArray *) passedTriggerArray : (NSMutableArray *)passedUpdaterArray{
	self = [super initWithImage:[UIImage imageNamed:@"AnimalFur_Movement_1.png"]];
	
	self.animationImages = [NSArray arrayWithObjects:
							[UIImage imageNamed:@"AnimalFur_Movement_1.png"],
							[UIImage imageNamed:@"AnimalFur_Movement_2.png"],
							[UIImage imageNamed:@"AnimalFur_Movement_3.png"],
							[UIImage imageNamed:@"AnimalFur_Movement_4.png"],nil];
	
	
	
	
	self.animationDuration = 0.3;
	self.animationRepeatCount = 0;
	[self startAnimating];
    if(self){
		
		health = 3;
		speed = 3;
		XPos =768/2;
		YPos = -100;
		
		
		aFish = passedFish;
		theLining = passedPreventerArray;
		aTriggerArray = passedTriggerArray;
		miscUpdateArray = passedUpdaterArray;
		
		isAttacking = FALSE;
		ignoreAvoidance = TRUE;
        [self setFrame:CGRectMake(XPos, YPos, 58, 48)];	
		
		[self addToView:self];	
		
		targetX = 768/2;
		targetY = 100;
		
		radialHeightSprite = 6000;
		radialWidthSprite = 600;
		
		

    }
    return self;
}

-(void) updateMe{
	[self move];
	[self checkCollisionWithFish];
}





-(void)spitProjectile{
	SpitProjectile *theSpit = [[SpitProjectile alloc] init:XPos : YPos : aFish : miscUpdateArray : theLining : aTriggerArray];
	[miscUpdateArray addObject: theSpit];
	
	[self.superview addSubview:theSpit];
	
	[theSpit release];
	
}

-(void) chooseTarget{
	
	targetX = arc4random() % 468 + 150;
	targetY = arc4random() % 704 + 150;
				
	[self spitProjectile];
	
	radialWidthSprite = 550;
}

- (void) animalFurDied : (BOOL) updateScore{
	if (updateScore) {
		[self updateScore];
	}
	DeathSplat *aSplat = [[DeathSplat alloc] init:XPos :YPos :miscUpdateArray : 2];
	[self.superview addSubview:aSplat];
	[self.superview sendSubviewToBack:aSplat];
	[aSplat release];
	
	[self removeFromSuperview];
	
	
	[aTriggerArray removeObject:self];
	

	
}


-(void) checkCollisionWithFish{
	float dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(aFish.XPos, aFish.YPos)];
	if(dist < 76.5)
		{
			
			[aFish hit : ignoreAvoidance];//if ignore avoidance is true that means enemy was spawning
			

			
			[self takeDamage];
			isFleeing = TRUE;
			
			if (self.health == 0) {
				[self animalFurDied : TRUE];				
			}
			else {
				[self flashSprite];
				isAttacking = FALSE;
			}
		}		
	}



@end