#import <QuartzCore/QuartzCore.h>
#import "Fish.h"
#import "AccController.h"


AccController *acc;

float width = 768;
float height = 1024;
float ball_radius = 50;
float friction = .6;

float radialHeight = 12000;
float radialWidth = 600;



@implementation Fish;
@synthesize XSpeed;
@synthesize YSpeed;

@synthesize XPos;
@synthesize YPos;



- (id)init {
    self = [super initWithImage:[UIImage imageNamed:@"sailor_movement_1.png"]];
	
	self.animationImages = [NSArray arrayWithObjects:
							[UIImage imageNamed:@"sailor_movement_1.png"],
							[UIImage imageNamed:@"sailor_movement_2.png"],
							[UIImage imageNamed:@"sailor_movement_3.png"],
							[UIImage imageNamed:@"sailor_movement_4.png"],
							[UIImage imageNamed:@"sailor_movement_5.png"],
							[UIImage imageNamed:@"sailor_movement_6.png"],nil];
	
	
	
	
	self.animationDuration = 0.3;
	self.animationRepeatCount = 0;
	[self startAnimating];
    if (self) {
        if(!acc)
        {
            acc = [[AccController alloc] init];
        }
		XPos = width/2;
		YPos = height - 100;
        [self setFrame:CGRectMake(0, 0, 105, 92)];
        
    }
    return self;
}

-(void) updateFish
{
	
	XSpeed += acc.gx;
 	YSpeed += acc.gy;
	
	
	
	float newX = XPos + XSpeed;
	float newY = YPos + YSpeed;
	CGPoint p = CGPointMake(newX, newY);
	bool ins = [self isInShape:p];
	
	if (newY > 981 && ins) {
		YPos = 981;
		YSpeed = -YSpeed;
		YSpeed *= friction;
	}
	else if (newY < 119 && ins){
		YPos = 119;
		YSpeed *= friction;
		YSpeed = -YSpeed;
	}
	else {
		
		
		
		if ([self isInShape: p] == FALSE) {
			CGPoint aPoint = [self pointOnCircleFromPoint:p];
			//CGPoint aPoint1 = [self pointOnCircleFromPoint:self.center];
			//equal the wal
			XPos = aPoint.x;
			YPos = aPoint.y;
			
			
			//make rebound --------------
			CGPoint fat = aPoint;
			fat.x -= 768/2;
			CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
			CGAffineTransform back = CGAffineTransformInvert(t);
			fat = CGPointApplyAffineTransform(fat, back);
			fat.x += 768/2;
			//.fat = aPoint;
			
			CGPoint inv = CGPointMake(XSpeed, YSpeed);
			
			//get normal vector
			CGPoint pp = CGPointMake(768/2, 1004/2);
			float dx = fat.x - pp.x;
			float dy = fat.y  - pp.y;
			dx *= 2;
			float dist = sqrtf(dx*dx + dy *dy);
			dx = dx/dist;
			dy = dy/dist;
			
			CGPoint n = CGPointMake(dx, dy);
			
			float dotproduct = n.x * inv.x + n.y * inv.y;
			
			XSpeed -= acc.gx;
			YSpeed -= acc.gy;
			
			XSpeed = XSpeed - 2*dotproduct*n.x;
			YSpeed = YSpeed - 2*dotproduct*n.y;
			//---------------------------
			
			////add Friction
			XSpeed *= friction;
			YSpeed *= friction;
			
			//remove residual speed
		
			//XSpeed = 0;
			//YSpeed = 0;
			
		}
	}
	
	
	YPos += YSpeed;
	XPos += XSpeed;
	//update points	
	
	
	
	
	
	[self setCenter:CGPointMake(XPos, YPos)];
	
}





-(void) hit :(BOOL)enemyWasSpawning
{
	if (enemyWasSpawning) {
		YSpeed = -YSpeed + 10;
		XSpeed = -XSpeed + 10;
	}else {
		YSpeed = -YSpeed;
		XSpeed = -XSpeed;
	}

	
	YSpeed *= friction;	
	XSpeed *= friction;
	
	XPos += XSpeed;
	YPos += YSpeed;
	
	[self setCenter:CGPointMake(XPos, YPos)];
}




/*
 -( bool) hitXtreme
 {
 
 CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
 CGAffineTransform back = CGAffineTransformInvert(t);
 
 CGMutablePathRef path = CGPathCreateMutable();
 //  CAShapeLayer *a = [[CAShapeLayer alloc] init];
 //  CGPathAddEllipseInRect(path, nil, CGRectMake(0, 0, 500, 500));
 //  a.path = path;
 //  CGPathRelease(path);
 
 // UIView *v = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 500, 500)];
 // [v.layer addSublayer:a];
 //[a release];
 
 
 //  v.transform = t;
 //  [self.superview addSubview:v];
 // [v setCenter:CGPointMake(768/2, 1004/2)];
 // [v release];
 }
 
 
 -(void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
 {
 CGPoint p = [[touches anyObject] locationInView:self.view];
 p.x -= 768/2;
 p.y -= 1004/2;
 
 CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
 CGAffineTransform back = CGAffineTransformInvert(t);
 p = CGPointApplyAffineTransform(p, back);
 p.x += 768/2;
 p.y += 1004/2;
 
 float dist = [self distFrom:CGPointMake(768/2, 1004/2) to:p];
 
 if (dist < 250)  {
 
 UIView *c = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 5, 5)];
 c.backgroundColor = [UIColor redColor];
 c.center = p;
 [self.view addSubview:c];
 [c release];
 } else
 {
 CGPoint rr = [self pointOnCircleFromPoint:p];
 
 UIView *c = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 5, 5)];
 c.backgroundColor = [UIColor greenColor];
 c.center = rr;
 [self.view addSubview:c];
 [c release];
 
 }
 
 }*/

//p is from zero zero in the top left 
-(bool) isInShape:(CGPoint)p
{
    //p.x -= 768/2;
    //p.y -= radialHeight/2;
    //
    //CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
    //CGAffineTransform back = CGAffineTransformInvert(t);
   // p = CGPointApplyAffineTransform(p, back);
    //p.x += 768/2;
    //p.y += radialHeight/2;
    CGPoint ponc = [self pointOnCircleFromPoint:p];
	float dd = [self distFrom:CGPointMake(768/2, (1004/2) + 75) to:ponc];
	
	
    float dist = [self distFrom:CGPointMake(768/2, (1004/2) + 75) to:p];
    
	if(dist <= dd)
	{
		return YES;
	}
	return NO;
    //if (dist < radialWidth)  {
      //  return true;
    //} 
    //return false;
}

//p is from zero zero in the top left 
-(CGPoint) pointOnCircleFromPoint:(CGPoint)p
{
    //move out of screen space.
    p.x -= 768/2;
    p.y -= radialHeight/2;
    CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
    CGAffineTransform back = CGAffineTransformInvert(t);
    //apply anti scale
    p = CGPointApplyAffineTransform(p, back);
    p.x += 768/2;
    p.y += radialHeight/2; 
    
    //get normal vector
    CGPoint pp = CGPointMake(768/2, 1004/2);
    float dx = p.x - pp.x;
    float dy = p.y  - pp.y;
    float dist = sqrtf(dx*dx + dy *dy);
    dx = dx/dist;
    dy = dy/dist;
    dx *= radialWidth * .5;
    dy *= radialWidth;
    
    //printf("%f\n", dy);
    
    pp.x += dx;
    pp.y += dy;
    return pp;
}



-(float) distFrom:(CGPoint)p1 to:(CGPoint)p2
{
    float dx = p1.x - p2.x;
    float dy = p1.y - p2.y;
    return sqrtf(dx*dx + dy*dy);
}

@end