//
//  GameViewController.h
//  Fish
//
//  Created by Daniel Loomb on 22/08/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Fish.h"
#import "PreventerWall.h"
//@class PreventerArray;
//@class PreventerLining;


@interface GameViewController : UIViewController {
	UILabel *scoreLabel;
	UILabel *tKindLabel;
	UILabel *killTimeLabel;
	UILabel *TimeLabel;
	UILabel *levelBeginLabel;
	
	UIButton *continueButton;
	UIButton *levelSelectButton;
	UIButton *mainMenuButton;
	UIButton *pauseButton;
	UIImageView *backgroundImage;
	UIImageView *lungOverlayImage;
	UIImageView *menuBackgroundImage;
	UIImageView *pauseScreenFade;
	
	//Controls for winning
	UIButton *proceedWin;
	UILabel *statusLabel;
	UILabel *statusSubLabel;
	
	//Controls for losing
	UIButton *proceedLose;
	UIButton *levelSelectLose;
	UIButton *mainMenuLose;
	
	
	int currentLevel;
	Fish *theFish;
	PreventerWall *preventerArray;
	NSMutableArray *triggersArray;
}

-(IBAction)goToMainMenu;
-(IBAction)pause;
-(IBAction)continueGame;
-(IBAction)menuItemLevelSelect;
-(IBAction)proceedLoseAction;

// methods to access variables
-(void)setLevel:(int)cLevel;
-(void)setFish:(Fish *)tFish;
-(void)setPreventerArray:(PreventerWall *)pArray;
-(void)setTriggersArray:(NSMutableArray *)tArray;
-(void)setMiscUpdateArray:(NSMutableArray *)mArray;
-(void)updateMiscTriggersByThemselves;



-(void)toggleTimer;
-(void)lockTimer;

-(void)forceWin;

@property (nonatomic, retain) IBOutlet UILabel *scoreLabel;
@property (nonatomic, retain) IBOutlet UILabel *tKindLabel;
@property (nonatomic, retain) IBOutlet UILabel *killTimeLabel;
@property (nonatomic, retain) IBOutlet UILabel *TimeLabel;
@property (nonatomic, retain) IBOutlet UILabel *levelBeginLabel;

@property (nonatomic, retain) IBOutlet UIButton *continueButton;
@property (nonatomic, retain) IBOutlet UIButton *levelSelectButton;
@property (nonatomic, retain) IBOutlet UIButton *mainMenuButton;
@property (nonatomic, retain) IBOutlet UIButton *pauseButton;
@property (nonatomic, retain) IBOutlet UIImageView *backgroundImage;
@property (nonatomic, retain) IBOutlet UIImageView *lungOverlayImage;
@property (nonatomic, retain) IBOutlet UIImageView *pauseScreenFade;
@property (nonatomic, retain) IBOutlet UIImageView *menuBackgroundImage;

@property (nonatomic, retain) IBOutlet UIButton *proceedWin;
@property (nonatomic, retain) IBOutlet UILabel *statusLabel;
@property (nonatomic, retain) IBOutlet UILabel *statusSubLabel;

@property (nonatomic, retain) IBOutlet UIButton *proceedLose;
@property (nonatomic, retain) IBOutlet UIButton *levelSelectLose;
@property (nonatomic, retain) IBOutlet UIButton *mainMenuLose;

@end
