//
//  InhalerWave.m
//  Fish
//
//  Created by Daniel Loomb on 28/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "InhalerWave.h"
#import "PreventerBubble.h"
#import "Sprite.h"
#import "AnimalFur.h"
#import "Sounds.h"

@implementation InhalerWave

@synthesize XPos;
@synthesize YPos;

@synthesize imageSize;
@synthesize theLining;
@synthesize Type;
@synthesize countdownToDisappear;
@synthesize Timer;
@synthesize aTriggerArray;
@synthesize updaterArray;

Sounds *aSound;

- (id)initPreventerWave :(int)givenX : (int)givenY : (PreventerWall *) passedWall : (NSMutableArray *) passedUpdateArray{
    self = [super initWithImage:[UIImage imageNamed:@"scaleablePreventerSplash.png"]];
    if(self){
		
		XPos = givenX;
		YPos = givenY;
		
		Type = 1;
		theLining = passedWall;
		
		updaterArray = passedUpdateArray;
		[passedUpdateArray addObject:self];
		aSound = [[Sounds alloc]initShared];
		[aSound PlayPreventer];
		
		imageSize = 50;
		[self setAlpha:self.alpha-.20];
        [self setFrame:CGRectMake(XPos- 25, YPos - 25, imageSize, imageSize)];
	//	Timer = [NSTimer scheduledTimerWithTimeInterval:1/60.0 target:self selector:@selector(update) userInfo:nil repeats:true];
		
		countdownToDisappear = 75;
		
    }
    return self;
}

-(id) initRelieverWave : (int)givenX : (int)givenY : (NSMutableArray *) passedTriggers : (NSMutableArray *) passedUpdateArray{
	self = [super initWithImage:[UIImage imageNamed:@"scaleableRelieverSplash.png"]];
    if(self){
		
		XPos = givenX;
		YPos = givenY;
		Type = 0;
		
		updaterArray = passedUpdateArray;
		[passedUpdateArray addObject:self];
		
		aSound = [[Sounds alloc]initShared];
		[aSound PlayReliever];
		
		imageSize = 50;
		[self setAlpha:self.alpha-.20];
		aTriggerArray = passedTriggers;
        [self setFrame:CGRectMake(XPos- 25, YPos - 25, imageSize, imageSize)];
		//Timer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(update) userInfo:nil repeats:true];
		
		countdownToDisappear = 75;
		
    }
    return self;
}

-(void) countdown{
	if (countdownToDisappear < 0) {
		[self removeFromSuperview];
		[updaterArray removeObject:self];
		[Timer invalidate];
		if(Type == 1){
			[self buildLayer];
		}		
		if (Type == 0) {
			[self killAllEnemies];
		}
	}
	else {
		[self setFrame:CGRectMake(XPos- (imageSize/2), YPos - (imageSize/2), imageSize += 10.0f, imageSize += 10.0f)];
		//self.transform = CGAffineTransformMakeScale(imageSize += 1.0f ,imageSize += 1.0f);
		countdownToDisappear--;
	}
	
	
}

-(void)buildLayer{
	for (int i =0; i < [theLining count]; i++) {
		NSMutableArray *tempArray = [theLining objectAtIndex:i];
			PreventerBubble *tempBubble = [tempArray lastObject];
			if (tempBubble.Health == 2 && [tempArray count] < 4) {
				int xPosition = tempBubble.XPos + 25;
				if (i > 37) {
					xPosition -= 50;
				}
				PreventerBubble *newBubble = [[PreventerBubble alloc] init: xPosition :tempBubble.YPos: 2 : tempBubble.arrayBubbleBelongsTo];
				[tempBubble.superview addSubview:newBubble];
				[tempBubble.superview sendSubviewToBack:newBubble];
				[tempArray addObject:newBubble];
				[newBubble release];
			}
			else {
				[tempBubble turnGreen];
			}
	}
	
}
-(void)killAllEnemies{
	
	for (int i = ([aTriggerArray count]-1); i >= 0; i--) {
		Sprite *tempSprite = [aTriggerArray objectAtIndex:i];
		if ([tempSprite isKindOfClass: [AnimalFur class]]) {
			AnimalFur *aFur = [aTriggerArray objectAtIndex:i];
			
			[aFur animalFurDied:FALSE];//////// <-----needs to be extended like the below spriteDied!! (Daniel, What the Hell does this mean?)
		}
		else {	
			
			[tempSprite spriteDied:FALSE];
		}
	}
}

@end
