//
//  LevelController.m
//  Fish
//
//  Created by Benjamin Squires on 27/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LevelController.h"
#import "Fish.h"
#import "DustMite.h"
#import "AnimalFur.h"
#import "Pollen.h"
#import "FluVirus.h"
#import "Cold.h"
#import "Smoke.h"
#import "DeathSplat.h"
#import "PreventerBubble.h"
#import "PreventerWall.h"
#import "PreventerPowerup.h"
#import "Sprite.h"



@implementation LevelController

UIViewController *gView;
Fish *theFish;
PreventerWall *preventerArray;
NSMutableArray *triggersArray;
NSMutableArray *miscUpdateArray;
int score;
-(id)init:(int)levelNumber:(GameViewController *)gameView
{
	gView = gameView;
	//instantiate the fish
	theFish = [[Fish alloc] init];
	[(GameViewController *)gView setFish:theFish];
	
	//init the preventer lining
	if (levelNumber == 1) {
		preventerArray = [[PreventerWall alloc] init:[gView view]]; //create a new lining for level 1
	} else {
		preventerArray = [[PreventerWall alloc] initFromFile:[gView view]:levelNumber]; //restore the previous lining
	}
	[(GameViewController *)gView setPreventerArray:preventerArray];
	
	triggersArray = [[NSMutableArray alloc]init];
	[(GameViewController *)gView setTriggersArray:triggersArray];
	
	miscUpdateArray = [[NSMutableArray alloc] init];
	[(GameViewController *)gView setMiscUpdateArray: miscUpdateArray];
	
	Sprite *initSprite = [[Sprite alloc] initSharedVariable:theFish :preventerArray :triggersArray : miscUpdateArray];
	[initSprite release];
	//Make preventer appear
	PreventerPowerup *aPreventer = [[PreventerPowerup alloc] init:arc4random() % 400 + 200 :arc4random() % 300 + 300 :theFish :preventerArray : miscUpdateArray];
	
	
	[aPreventer release];								
	
	[(GameViewController *)gView setLevel:levelNumber];
	
	switch (levelNumber) {
		case 1:
			[self level01];
			break;
			
		case 2:
			[self level02];
			break;
			
		case 3:
			[self level03];
			break;
			
		case 4:
			[self level04];
			break;
			
		case 5:
			[self level05];
			break;
			
		case 6:
			[self level06];
			break;
			
		case 7:
			[self level07];
			break;
			
		case 8:
			[self level08];
			break;
			
		case 9:
			[self level09];
			break;
			
		case 10:
			[self level10];
			break;
			
		default:
			printf("Level select default case\n");
			break;
	}
	
	//[triggersArray release]; //do i need this code? maybe an auto release? release everything? more questions?
	//[preventerArray release];
	[theFish release];
	[gView release];
	return 0;
}

-(void)level01  /* LEVEL 1 :   10 DustMites */
{
	DustMite *theMite;
	for (int i = 0; i < 5; i++) {
		theMite = [[DustMite alloc]init];
		

		
		[theMite release];
	}
}

-(void)level02  /* LEVEL 2 :   5 DustMites,  5 Animal Fur */
{
	DustMite *theMite;
	for (int i = 0; i < 5; i++) {
		theMite = [[DustMite alloc]init];
		
		
		
		[theMite release];
	}
	AnimalFur *theFur;
	for (int i = 0; i < 5; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];

	
		[theFur release];
	}
	
}

-(void)level03    /* LEVEL 3 :   3 DustMites,  2 Animal Fur,  5 Pollen */
{
	DustMite *theMite;
	for (int i = 0; i < 5; i++) {
		theMite = [[DustMite alloc]init];
		
		
		
		[theMite release];
	}
	AnimalFur *theFur;
	for (int i = 0; i < 3; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
		
		
		[theFur release];
	}
	Pollen *aPollen;
	for (int i = 0; i < 5; i++) {
		aPollen = [[Pollen alloc] init];
	

	
		[aPollen release];
	}
}

-(void)level04	/* LEVEL 4 :   3 DustMites,  3 Animal Fur,  5 Pollen,  5 Cold */
{
	DustMite *theMite;
	for (int i = 0; i < 3; i++) {
		theMite = [[DustMite alloc]init];
		[theMite release];
	}
	
	FluVirus *aVirus;
	for (int i = 0; i < 5; i++) {
		aVirus = [[FluVirus alloc] init];	
		[aVirus release];
	}
	
	/*AnimalFur *theFur;
	for (int i = 0; i < 4; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
		[theFur release];
	}
	
	for (int i = 0; i < 2; i++) {
		aVirus = [[FluVirus alloc] init];
		[aVirus release];
	}
	*/
	Pollen *aPollen;
	for (int i = 0; i < 4; i++) {
		aPollen = [[Pollen alloc] init];
		[aPollen release];
	}
	/*
	for (int i = 0; i < 4; i++) {
		aVirus = [[FluVirus alloc] init];
		[aVirus release];
	}*/
}

-(void)level05	/* LEVEL 5 :   3 DustMites,  3 Animal Fur,  3 Pollen,  3 Cold,  5 FluVirus */
{
	/*DustMite *theMite;
	for (int i = 0; i < 3; i++) {
		theMite = [[DustMite alloc]init];
		
		
		
		[theMite release];
	}*/
	AnimalFur *theFur;
	for (int i = 0; i < 3; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
		
		
		[theFur release];
	}
	Pollen *aPollen;
	for (int i = 0; i < 3; i++) {
		aPollen = [[Pollen alloc] init];
		
		
		
		[aPollen release];
	}
	Cold *aCold;
	for (int i = 0; i < 5; i++) {
		aCold = [[Cold alloc] init];
		
		
		[aCold release];
	}
	FluVirus *aVirus;
	for (int i = 0; i < 5; i++) {
		aVirus = [[FluVirus alloc] init];			

	
		[aVirus release];
	}
}

-(void)level06	/* LEVEL 6 :   3 DustMites,  3 Animal Fur,  3 Pollen,  3 Cold,  5 FluVirus, 3 Smoke */
{
	/*DustMite *theMite;
	for (int i = 0; i < 3; i++) {
		theMite = [[DustMite alloc]init];
		
		
		
		[theMite release];
	}
	AnimalFur *theFur;
	for (int i = 0; i < 3; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
		
		
		[theFur release];
	}*/
	Pollen *aPollen;
	for (int i = 0; i < 3; i++) {
		aPollen = [[Pollen alloc] init];
		
		
		
		[aPollen release];
	}
	/*
	Cold *aCold;
	for (int i = 0; i < 3; i++) {
		aCold = [[Cold alloc] init];
		
		
		[aCold release];
	}*/
	FluVirus *aVirus;
	for (int i = 0; i < 5; i++) {
		aVirus = [[FluVirus alloc] init];			
		
		
		[aVirus release];
	}
	
	Smoke *aSmoke;
	for (int i = 0; i < 5; i++) {
		aSmoke = [[Smoke alloc] init];

	
		[aSmoke release];
	}
}

-(void)level07
{
	DustMite *theMite;
	for (int i = 0; i < 5; i++) {
		theMite = [[DustMite alloc]init];
		
		
		
		[theMite release];
	}
	AnimalFur *theFur;
	for (int i = 0; i < 3; i++) {
		theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
		
		
		[theFur release];
	}
	Pollen *aPollen;
	for (int i = 0; i < 2; i++) {
		aPollen = [[Pollen alloc] init];
		
		
		
		[aPollen release];
	}
	Cold *aCold;
	for (int i = 0; i < 1; i++) {
		aCold = [[Cold alloc] init];
		
		
		[aCold release];
	}
	FluVirus *aVirus;
	for (int i = 0; i < 2; i++) {
		aVirus = [[FluVirus alloc] init];			
		
		
		[aVirus release];
	}
	
	Smoke *aSmoke;
	for (int i = 0; i < 1; i++) {
		aSmoke = [[Smoke alloc] init];
		
		
		[aSmoke release];
	}
	
}

-(void)level08
{
	
	
	printf("level 8 selected\n");
	DustMite *aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	Pollen *aPollen = [[Pollen alloc] init];
	aPollen = [[Pollen alloc] init];
	
	AnimalFur *theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	
	Cold *aCold;
	aCold = [[Cold alloc] init];
	
	FluVirus *aFlu;
	aFlu = [[FluVirus alloc] init];
	aFlu = [[FluVirus alloc] init];
	
	Smoke *aSmoke;
	aSmoke = [[Smoke alloc] init];
	aSmoke = [[Smoke alloc] init];
}

-(void)level09
{
	printf("level 9 selected\n");
	DustMite *aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	aMite = [[DustMite alloc] init];
	
	Pollen *aPollen = [[Pollen alloc] init];
	aPollen = [[Pollen alloc] init];
	
	AnimalFur *theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	theFur = [[AnimalFur alloc] init: theFish : preventerArray : triggersArray : miscUpdateArray];
	
	Cold *aCold;
	aCold = [[Cold alloc] init];
}

-(void)level10
{
	Cold *aCold;
	aCold = [[Cold alloc] init];
	aCold = [[Cold alloc] init];
	aCold = [[Cold alloc] init];
	
	FluVirus *aFlu;
	aFlu = [[FluVirus alloc] init];
	aFlu = [[FluVirus alloc] init];
	
	Smoke *aSmoke;
	aSmoke = [[Smoke alloc] init];
	aSmoke = [[Smoke alloc] init];
}

- (void)dealloc {
    [super dealloc];
}


@end
