//
//  PreventerBubble.m
//  Fish
//
//  Created by Daniel Loomb on 20/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PreventerBubble.h"
#import "RelieverPowerup.h"


@implementation PreventerBubble

@synthesize XPos;
@synthesize YPos;
@synthesize Health;
@synthesize timer;
@synthesize arrayBubbleBelongsTo;

-(id)init : (float)givenXpos : (float)givenYpos : (int)bubbleHealth : (NSMutableArray *) passedArrayBubbleBelongs{
    
    self = [super initWithImage:[UIImage imageNamed:@"preventerLining_healthy.png"]];
	
    if (self) {
		Health = bubbleHealth;
        XPos = givenXpos;
		YPos = givenYpos;
		arrayBubbleBelongsTo = passedArrayBubbleBelongs;
		
		
		
		[self setFrame:CGRectMake(XPos, YPos, 25, 25)];
	}
    return self;
}

-(void)removeSelf{
	//printf("Removing Self - My X was = %i, My Y was = %i, So long.\n", XPos, YPos);
	[self removeFromSuperview];
}

-(void)takeDamage{
	//printf("Taking Damage - My X was = %i, My Y was = %i, Ouch.\n", XPos, YPos);
	Health --;
	
}

-(void)turnBlueOrBlack : (NSMutableArray *) passedUpdaterArray : (int) type{
	if ([self.image isEqual:[UIImage imageNamed:@"preventerLining_frozen.png"]] || 
					[self.image isEqual:[UIImage imageNamed:@"preventerLining_smokeDamaged.png"]]) {
		
	}
	else{
		if (type == 0) {
			self.image = [UIImage imageNamed:@"preventerLining_frozen.png"];
		}
		else {
			self.image = [UIImage imageNamed:@"preventerLining_smokeDamaged.png"];
		}

		
		updaterArray = passedUpdaterArray;
		
		self.Health = 10;
		[passedUpdaterArray addObject:self];
		count = 100;
		//timer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(countingDown) userInfo:nil repeats:true];
	}
}

-(void)turnGreen {
	self.image = [UIImage imageNamed:@"preventerLining_healthy.png"];
	self.Health = 2;
}


-(void)countdown{
	if (count == 0) {
		[updaterArray removeObject:self];
		[self removeSelf];
		[arrayBubbleBelongsTo removeObject:self];
	}
	else {
		count --;
	}
	
}

-(void)turnRed{
	self.image = [UIImage imageNamed:@"preventerLining_damaged.png"];
}

-(BOOL)checkHealth{
	if (Health == 0) {//If the bubble's health is 0 its time to destroy it so do...
		
		if ([arrayBubbleBelongsTo count] != 0) {//if the bubble was NOT the last one in the array do...
			
			//remove bubble from screen
			[self removeSelf];	
			
			//remove bubble from its array
			[arrayBubbleBelongsTo removeLastObject];			
		}
		
		
	}
	else if (Health == 1 && [arrayBubbleBelongsTo count] == 1){
		return TRUE;
		
	}
	return FALSE;
	
}


/*
 // Only override drawRect: if you perform custom drawing.
 // An empty implementation adversely affects performance during animation.
 - (void)drawRect:(CGRect)rect {
 // Drawing code.
 }
 */

- (void)dealloc {
    [super dealloc];
}


@end
