//
//  PreventerWall.m
//  Fish
//
//  Created by Daniel Loomb on 20/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PreventerWall.h"
#import "PreventerBubble.h"



@implementation PreventerWall

//@synthesize masterView;

int pBubble_diameter = 25;


-(id)init : (UIView *) theController{
		
	//masterView = theController;
	self = [[NSMutableArray alloc]init];
	//Create the Preveter Wall
	int loopCount = (int)(((929/pBubble_diameter)+ 1)*2);  //the height of the screen divided by the diameter of a bubble, 
																	//then added 1 for good measure, then times by two for both sides of scree
	printf("Loop Count = %i\n", loopCount);
	for (int i = 0; i < loopCount; i++) {
		
		NSMutableArray *tempArray = [[NSMutableArray alloc]init];
		
		for (int j = 0; j < 1; j++) {
			float bubbleX;
			float bubbleY;
			int zim = 19;
			int gir = 58;
			if (i < (loopCount /2)) {//first wall
				float wallCurveOffset;
				
				if (i < (loopCount / 4)) {
					wallCurveOffset = ((zim - i) * 35) * (1/(6.0 + i)) + 10;
					
					bubbleX = wallCurveOffset +  (pBubble_diameter * j);//X position to give the bubble
					bubbleY = (pBubble_diameter * (i + 3));//Y position to give the bubble
					
				}
				else {
					wallCurveOffset = (35 * (i - zim)) * (1/(26.0 - (i - zim))) + 10;
					
					bubbleX =  wallCurveOffset + (pBubble_diameter * j);//X position to give the bubble
					bubbleY = (pBubble_diameter * (i + 3));//Y position to give the bubble
					
				}				
			}
			else {//opposite wall
				float wallCurveOffset;
				
				if (i < (loopCount - (loopCount /4))) {					
					wallCurveOffset = (35 * (gir - i)) * (1/(26.0 + (i - gir))) + 10;
					
					bubbleX =  (768 - (pBubble_diameter *(j +1))) - wallCurveOffset;//X position to give the bubble
					bubbleY = (((i +3) - (loopCount /2)) * pBubble_diameter);//Y position to give the bubble
					
				}
				else {
					
					wallCurveOffset = (35 * (i - gir)) * (1/(26.0 - (i - gir))) +13;
					
					
					bubbleX = (768 - (pBubble_diameter *(j +1))) - wallCurveOffset;//X position to give the bubble
					bubbleY = (((i + 3) - (loopCount /2)) * pBubble_diameter);//Y position to give the bubble
					
				}	
				
			}
					
					

			PreventerBubble *aBubble = [[PreventerBubble alloc] init :bubbleX : bubbleY : 2 : tempArray];
			[theController addSubview:aBubble];
			[theController sendSubviewToBack:aBubble];
			[tempArray insertObject:aBubble atIndex:j];
			[aBubble release];
		}
		[self insertObject:tempArray atIndex:i];	
	}
	printf("Lining Created\n");
	

	
	
	return self;
}

-(id)initFromFile : (UIView *) theController : (int)level {
	self = [[NSMutableArray alloc]init];
	NSUserDefaults *wallState = [NSUserDefaults standardUserDefaults];
	for (int i = 0; i < 76; i++) {
		NSMutableArray *tempArray = [[NSMutableArray alloc]init];
		for (int j = 0; j < [wallState integerForKey:[NSString stringWithFormat:@"%isectionLength%i", level - 1, i]]; j++) { // length of section
			PreventerBubble *aBubble = [[PreventerBubble alloc] init 
										: [wallState floatForKey:[NSString stringWithFormat:@"%ibubbleX%i%i", level - 1, j, i]] // x pos
										: [wallState floatForKey:[NSString stringWithFormat:@"%ibubbleY%i%i", level - 1, j, i]] // y pos
										: [wallState integerForKey:[NSString stringWithFormat:@"%ibubbleHealth%i%i", level - 1, j, i]] // health
										: tempArray];
			
			[theController addSubview:aBubble];
			[theController sendSubviewToBack:aBubble];
			if ([aBubble Health] == 1 ) {
				[aBubble turnRed];
			}
			[tempArray insertObject:aBubble atIndex:j];
			[aBubble release];
			
		}
		
		[self insertObject:tempArray atIndex:i];
		
	}
	
	printf("Lining Restored\n");
	return self;

}

@end
