//
//  PreventerPowerup.m
//  Fish
//
//  Created by Daniel Loomb on 20/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RelieverPowerup.h"
#import "PreventerBubble.h"
#import "Sprite.h"
#import "AnimalFur.h"
#import "InhalerWave.h"

int relieverCount = 1;
BOOL testUsedReliever;

@implementation RelieverPowerup

@synthesize aTriggerArray;

-(id)init : (int)givenXpos : (int)givenYpos : (Fish *) passedFish : (NSMutableArray *) passedTriggers : (NSMutableArray *) passedUpdateArray{
    
    self = [super initWithImage:[UIImage imageNamed:@"reliever_bounce_1.png"]];
	
	
	self.animationImages = [NSArray arrayWithObjects:
							[UIImage imageNamed:@"reliever_bounce_1.png"],
							[UIImage imageNamed:@"reliever_bounce_2.png"],
							[UIImage imageNamed:@"reliever_bounce_3.png"],
							[UIImage imageNamed:@"reliever_bounce_4.png"],
							[UIImage imageNamed:@"reliever_bounce_5.png"],
							[UIImage imageNamed:@"reliever_bounce_6.png"],
							[UIImage imageNamed:@"reliever_bounce_7.png"],nil];
	
	
	
	
	self.animationDuration = 0.5;
	self.animationRepeatCount = 0;
	[self startAnimating];
	
    if (self) {
		if (relieverCount == 1) {
			
			relieverCount = 0;
			
			printf("Make Reliever Appear!\n");
			XPos = givenXpos;
			YPos = givenYpos;
			count = 500;
			//Timer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(countdown) userInfo:nil repeats:true];
			
			aFish = passedFish;
			aTriggerArray = passedTriggers;
			updaterArray = passedUpdateArray;
			testUsedReliever = FALSE;
			[passedUpdateArray addObject:self];
			[passedFish.superview addSubview:self];
			[passedFish.superview sendSubviewToBack:self];
			
			[self setFrame:CGRectMake(XPos- (101/2), YPos - (101/2), 101, 101)];
			
		}
	}
    return self;
}

-(void) checkFish{
	float dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(aFish.XPos, aFish.YPos)];
	if (dist < 95) {
		
		InhalerWave *theWave = [[InhalerWave alloc] initRelieverWave: XPos :YPos : aTriggerArray : updaterArray];
		[self.superview addSubview:theWave];
		testUsedReliever = TRUE;
		[aFish hit : FALSE];
		[self removeFromSuperview];
		//[updaterArray removeObject:self];


	}
	
}



-(void)resetReliever{
	relieverCount = 1;
}

-(BOOL)checkIfRelieverWasUsed{
	return testUsedReliever;
}



- (void)dealloc {
    [super dealloc];
}


@end
