    //
//  ScoreCalculatorViewController.m
//  Fish
//
//  Created by Daniel Loomb on 3/10/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ScoreCalculatorViewController.h"
#import "FishViewController.h"
#import "GameViewController.h"
#import "LevelController.h"
#import "PreventerBubble.h"



@implementation ScoreCalculatorViewController

@synthesize elapsedTimeMinutes;
@synthesize elapsedTimeSeconds;
@synthesize TotalScore;
@synthesize RelieverUsed;

@synthesize CalcTimer;


@synthesize star1Image;
@synthesize star2Image;
@synthesize star3Image;

@synthesize TriggerScoreLabel;
@synthesize TimeBonusLabel;
@synthesize NoRelieverBonusLabel;
@synthesize FinalScoreLabel;


@synthesize continueButton;
@synthesize backButton;

int count;
int countTimeBouns;
int countRelieverBonus;
int countFinalScore;
int starRating;
PreventerWall *preventerArray;

- (id)initSelf: (int)elapsedMins : (int)elapsedSecs : (int)finalScore : (BOOL)relieverUsed: (int)cLevel: (PreventerWall *) pArray {
	//self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	if (self) {
		preventerArray = pArray;
		currentLevel = cLevel;

		//Calc Time Bonus
		countTimeBouns = 500 -((60 * elapsedMins) + elapsedSecs);
							  
			if (countTimeBouns < 0) {
				countTimeBouns = 0;
			}
		
		//Calc Reliever Bonus
		countRelieverBonus = 0;
		if (relieverUsed == FALSE) {
			countRelieverBonus = 1000;
		}
		
		starRating = 0;
	

		TotalScore = finalScore;
		
	
		
	
		
		count = 0;
	}
	return self;
}

-(IBAction)back
{
	FishViewController *menuView = [[FishViewController alloc] initWithNibName:NULL bundle:NULL];
	
	[self presentModalViewController:menuView animated:NO];
}

-(IBAction)nextLevel
{
	//start the next level view controller
	GameViewController *gameView = [[GameViewController alloc] initWithNibName:NULL bundle:NULL];
	[self presentModalViewController:gameView animated:NO];
	[[[LevelController alloc] init:currentLevel + 1:gameView] release];
}

-(IBAction)tryAgain{
	GameViewController *gameView = [[GameViewController alloc] initWithNibName:NULL bundle:NULL];
	[self presentModalViewController:gameView animated:NO];
	[[[LevelController alloc] init:currentLevel:gameView] release];	
}

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil : (int)elapsedMins : (int)elapsedSecs : (int)finalScore : (bool)relieverUsed{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	[continueButton.titleLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	[backButton.titleLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	[TriggerScoreLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	[TimeBonusLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	[NoRelieverBonusLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	[FinalScoreLabel setFont:[UIFont fontWithName:@"AppleCasual" size:48]];
	[HintsLabel setFont:[UIFont fontWithName:@"AppleCasual" size:20]];
	[tryAgainButton.titleLabel setFont:[UIFont fontWithName:@"AppleCasual" size:36]];
	
	
	CalcTimer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(CalculateTrigger) userInfo:nil repeats:true];

}


-(void) CalculateTrigger{
	count += 10;
		[TriggerScoreLabel setText:[NSString stringWithFormat:@"TriggerScore: %i", count]];
	[self centerLabel:TriggerScoreLabel];
	if (count > TotalScore) {
		[TriggerScoreLabel setText:[NSString stringWithFormat:@"TriggerScore: %i", TotalScore]];
	[self centerLabel:TriggerScoreLabel];
		[CalcTimer invalidate];
		count = 0;
		CalcTimer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(CalculateTimeBonus) userInfo:nil repeats:true];
	}
	
}

-(void) CalculateTimeBonus{
	count += 20;
	[TimeBonusLabel setText:[NSString stringWithFormat:@"Time Bonus: %i", count]];
	[self centerLabel:TimeBonusLabel];
	if (count > countTimeBouns) {
		[TimeBonusLabel setText:[NSString stringWithFormat:@"Time Bonus: %i", countTimeBouns]];
		[self centerLabel:TimeBonusLabel];
		[CalcTimer invalidate];
		count = 0;
		CalcTimer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(CalculateRelieverBonus) userInfo:nil repeats:true];
	}
}

-(void) CalculateRelieverBonus{
	count += 30;
	[NoRelieverBonusLabel setText:[NSString stringWithFormat:@"Reliever-Free Bonus: %i", count]];
	[self centerLabel:NoRelieverBonusLabel];
	if (count > countRelieverBonus) {
		[NoRelieverBonusLabel setText:[NSString stringWithFormat:@"Reliever-Free Bonus: %i", countRelieverBonus]];
		[self centerLabel:NoRelieverBonusLabel];
		[CalcTimer invalidate];
		count = 0;
		CalcTimer = [NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(CalculateFinalScore) userInfo:nil repeats:true];
	}
}

-(void) CalculateFinalScore{
	count += 100;
	[FinalScoreLabel setText:[NSString stringWithFormat:@"Final Score: %i", count]];
	[self centerLabel:FinalScoreLabel];
	
	if (count > (TotalScore + countTimeBouns + countRelieverBonus)) {
		[FinalScoreLabel setText:[NSString stringWithFormat:@"Final Score: %i", (TotalScore + countTimeBouns + countRelieverBonus)]];
		[self centerLabel:FinalScoreLabel];
		[CalcTimer invalidate];
		count = 0;
		CalcTimer = nil;
	
		
		TotalScore = TotalScore + countTimeBouns + countRelieverBonus;
		
		// write scores out
		NSUserDefaults *gameState = [NSUserDefaults standardUserDefaults];
		[gameState synchronize];
		[gameState setInteger:TotalScore forKey:[NSString stringWithFormat:@"score%i", currentLevel]];
		
		[self updateStarRating:currentLevel];
		
		[gameState setInteger:starRating forKey:[NSString stringWithFormat:@"rating%i", currentLevel]];
		
		//tricky shit time
		int i = 0;
		for (id row in preventerArray) {
			int j = 0;
			for (id bubble in row) {
				[gameState setFloat:[bubble XPos] forKey:[NSString stringWithFormat:@"%ibubbleX%i%i", currentLevel, j, i]];
				[gameState setFloat:[bubble YPos] forKey:[NSString stringWithFormat:@"%ibubbleY%i%i", currentLevel, j, i]];
				[gameState setInteger:[bubble Health] forKey:[NSString stringWithFormat:@"%ibubbleHealth%i%i", currentLevel, j, i]];
				
				j++;
				
			}
			[gameState setInteger:j forKey:[NSString stringWithFormat:@"%isectionLength%i", currentLevel, i]];
			
			i++;
		}
		
		if (currentLevel == 10) {
			continueButton.hidden = TRUE;
		}else if (starRating < 3) {
			continueButton.hidden = TRUE;
			tryAgainButton.hidden = FALSE;
			HintsLabel.hidden = FALSE;
		}else{
			continueButton.enabled = YES;
		}
		
		backButton.enabled = YES;
		
		
	}
}

-(void)updateStarRating : (int)cLevel{

	int scoreToCheckAgainst;	
	
	switch (cLevel) {
		case 1:
			scoreToCheckAgainst = 1500;
			break;
		case 2:
			scoreToCheckAgainst = 1500;
			break;
			
		case 3:
			scoreToCheckAgainst = 1500;
			break;
		case 4:
			scoreToCheckAgainst = 1500;
			break;
		case 5:
			scoreToCheckAgainst = 1500;
			break;
		case 6:
			scoreToCheckAgainst = 1500;
			break;
		case 7:
			scoreToCheckAgainst = 1500;
			break;
		case 8:
			scoreToCheckAgainst = 1500;
			break;
		case 9:
			scoreToCheckAgainst = 1500;
			break;
		default:
			scoreToCheckAgainst = 1500;
			break;
	}
	
	if (TotalScore >= (scoreToCheckAgainst/3)) {
		star1Image.image = [UIImage imageNamed:@"levelEndStar.png"];
		starRating = 1;
	}
	if (TotalScore >= ((scoreToCheckAgainst /3)*2)) {
		star2Image.image = [UIImage imageNamed:@"levelEndStar.png"];
		starRating = 2;
	}
	if (TotalScore >= scoreToCheckAgainst) {
		star3Image.image = [UIImage imageNamed:@"levelEndStar.png"];
		starRating = 3;
	}
}

-(void)centerLabel : (UILabel *) theLabel{
	[theLabel sizeToFit];
	[theLabel setCenter:CGPointMake(768/2 + 2, theLabel.center.y)];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return NO;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
