//
//  Sounds.m
//  Fish
//
//  Created by Daniel Loomb on 3/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Sounds.h"
#import "ObjectAL.h"

//define BGM
#define BGM_BACK_ON_TRACK @"Back on Track.mp3"
#define BGM_COMPARSA @"Comparsa.mp3"
#define BGM_PEPPY_PEPE @"Peppy Pepe.mp3"
#define BGM_SANCHO_PANZA_GETS_A_LATTE @"Sancho Panza gets a Latte.mp3"


//define SFX
#define BEEP_SOUND @"beep.wav"
#define BOMB_SOUND @"bomb.wav"
#define BOUNCE1_SOUND @"bounce.wav"
#define BOUNCE2_SOUND @"bounce2.wav"
#define BOUNCE3_SOUND @"bounce3.wav"
#define BOUNCE4_SOUND @"bounce4.wav"
#define BOUNCE5_SOUND @"bounce5.wav"
#define BURN_SOUND @"burn.wav"
#define DEATH1_SOUND @"death.wav"
#define DEATH2_SOUND @"death2.wav"
#define DEATH3_SOUND @"death3.wav"
#define DEATH4_SOUND @"death4.wav"
#define DEATH5_SOUND @"death5.wav"
#define DEATH6_SOUND @"death6.wav"
#define DESTOY_BUBBLE_SOUND @"destroyBubble.wav"
#define FROZEN_SOUND @"frozen.wav"
#define HIT_BUBBLE_SOUND @"hitBubble.wav"
#define PREVENTER_SOUND @"preventer.wav"
#define RELIEVER_SOUND @"reliever.wav"
#define SPIT_SOUND @"Spit.wav"


@implementation Sounds

BOOL soundMute;
BOOL musicMute;

-(id)initShared{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	
	soundMute = [defaults boolForKey:@"soundMute"];
	musicMute = [defaults boolForKey:@"musicMute"];
	return self;
}



-(id)init
{
	if (nil != (self = [super init])) {
		[OALSimpleAudio sharedInstance].allowIpod = NO;
		
		[OALSimpleAudio sharedInstance].honorSilentSwitch = YES;
		
		
		//Preload all the SFX
		[[OALSimpleAudio sharedInstance] preloadEffect:BEEP_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOMB_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOUNCE1_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOUNCE2_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOUNCE3_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOUNCE4_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BOUNCE5_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:BURN_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH1_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH2_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH3_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH4_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH5_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DEATH6_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:DESTOY_BUBBLE_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:FROZEN_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:HIT_BUBBLE_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:PREVENTER_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:RELIEVER_SOUND];
		[[OALSimpleAudio sharedInstance] preloadEffect:SPIT_SOUND];
		
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		
		soundMute = [defaults boolForKey:@"soundMute"];
		musicMute = [defaults boolForKey:@"musicMute"];
	}
	return self;
}

-(void) BGMStart : (int) type {
	if (musicMute)return;
	switch (type) {
		case 1:
			[[OALSimpleAudio sharedInstance] playBg:BGM_BACK_ON_TRACK];
			break;
		case 2:
			[[OALSimpleAudio sharedInstance] playBg:BGM_COMPARSA];
			break;
		default:
			[[OALSimpleAudio sharedInstance] playBg:BGM_PEPPY_PEPE];
			break;
	}
}

-(void) BGMPause{
	if (musicMute)return;
	[OALSimpleAudio sharedInstance].paused = YES;
}

-(void) BGMResume{
	if (musicMute)return;
	[OALSimpleAudio sharedInstance].paused = NO;
}

-(void) PlayBeep{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:BEEP_SOUND];
}

-(void) PlayBomb{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:BOMB_SOUND];
}

-(void) PlayBounce : (int) type{
	if (soundMute)return;
	switch (type) {
		case 1:
			[[OALSimpleAudio sharedInstance] playEffect:BOUNCE1_SOUND];
			break;
		case 2:
			[[OALSimpleAudio sharedInstance] playEffect:BOUNCE2_SOUND];
			break;
		case 3:
			[[OALSimpleAudio sharedInstance] playEffect:BOUNCE3_SOUND];
			break;
		case 4:
			[[OALSimpleAudio sharedInstance] playEffect:BOUNCE4_SOUND];
			break;
		default:
			[[OALSimpleAudio sharedInstance] playEffect:BOUNCE5_SOUND];
			break;
	}
	
}


-(void) PlayBurn{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:BURN_SOUND];
}

-(void) PlayDeath1{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH1_SOUND];
}

-(void) PlayDeath2{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH2_SOUND];
}

-(void) PlayDeath3{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH3_SOUND];
}

-(void) PlayDeath4{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH4_SOUND];
}

-(void) PlayDeath5{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH5_SOUND];
}

-(void) PlayDeath6{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DEATH6_SOUND];
}

-(void) PlayDestroyBubble{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:DESTOY_BUBBLE_SOUND];
}

-(void) PlayFrozen{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:FROZEN_SOUND];
}

-(void) PlayHitBubble{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:HIT_BUBBLE_SOUND];
}

-(void) PlayPreventer{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:PREVENTER_SOUND];
}

-(void) PlayReliever{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:RELIEVER_SOUND];
}

-(void) PlaySpit{
	if (soundMute)return;
	[[OALSimpleAudio sharedInstance] playEffect:SPIT_SOUND];
}

-(void) Quit{
	if (musicMute) return;
	[[OALSimpleAudio sharedInstance] stopEverything];
	
	[[OALSimpleAudio sharedInstance] unloadAllEffects];
}


@end
