//
//  SpitProjectile.m
//  Fish
//
//  Created by Daniel Loomb on 8/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SpitProjectile.h"
#import <math.h>
#import "PreventerBubble.h"
#import "RelieverPowerup.h"
#import "PreventerWall.h"


@implementation SpitProjectile

@synthesize arraySpitIsIn;

PreventerWall *theLining;
Fish *aFish;
NSMutableArray *aTriggerArray;

- (id)init :(int)randomX : (int)randomY : (Fish *) passedFish : (NSMutableArray *) passedArray : (PreventerWall *) passedWall : (NSMutableArray *) triggerArray{
    self = [super initWithImage:[UIImage imageNamed:@"spit.png"]];
    if(self){
		
		XPos = randomX;
		YPos = randomY;		
		speed = 5;
		theLining = passedWall;
		aTriggerArray = triggerArray;
		aFish = passedFish;
		
		//targetX = (int)passedFish.XPos;
		//targetY = (int)passedFish.YPos;
		arraySpitIsIn = passedArray;
		
		[self chooseLining];
		
        [self setFrame:CGRectMake(XPos, YPos, 25, 25)];
		
		//[NSTimer scheduledTimerWithTimeInterval:1/30.0 target:self selector:@selector(move) userInfo:nil repeats:true];
		
	

		
    }
    return self;
}

-(void) countdown{
	float dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(targetX, targetY)];
	if (dist < 10) {
		
		[super killPreventerBubble];
		
		[self spriteDied:FALSE];
		[self removeFromSuperview];
		[arraySpitIsIn removeObject:self];
		
	}
	dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(aFish.XPos, aFish.YPos)];
	if (dist < 50) {
		[self spriteDied:FALSE];
		[self removeFromSuperview];
		[arraySpitIsIn removeObject:self];
		
	}
	
	
	
	//Works out the direction to head to get to the target
	float dxTarget = XPos - targetX;
	float dyTarget = YPos - targetY;	
	direction = atan2(dyTarget, dxTarget);
	
	//works out the speed to apply for the given direction	
	XPos -= speed * cos(direction);
	YPos -= speed * sin(direction);
	[self setCenter:CGPointMake(XPos, YPos)];
}

-(void) removeSelf{
	[self removeFromSuperview];
}

@end
