//
//  Sprite.h
//  Fish
//
//  Created by Benjamin Squires on 6/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Fish.h"
#import "PreventerWall.h"

@interface Sprite : UIImageView {
	//Sprites Position on Screen	
	int XPos;
	int YPos;
	
	//Where Sprite Is going to go on screen
	int targetX;
	int targetY;
	
	//Other Properties
	int health;
	float direction;
	float speed;
	float radialHeightSprite;
	float radialWidthSprite;
	NSTimer *countdownTimer;
	int counter;
	
	//Where this Sprite is in the Global Update Array
	//int index;
	
	//Whether the current Sprite is attacking the lining
	bool isAttacking;
	
	bool ignoreAvoidance;
	bool isFleeing;
	
	//Pointers to Global Objects
	//Fish *aFish;
	//NSMutableArray *aTriggerArray;
	//PreventerWall *theLining;
	NSMutableArray *arrayBubbleWasIn;
	int indexOfArrayBubbleWasIn;
	
}

/*
 *	Declaring Variables as Properties so they can be Accessed outside Of Sprite Class
 */
@property int XPos;
@property int YPos;

@property int targetX;
@property int targetY;

@property int health;
@property float direction;
@property float speed;
//@property int index;
@property bool isAttacking;
@property bool isFleeing;
@property bool ignoreAvoidance;

/*
@property (nonatomic, retain)Fish *aFish;
@property (nonatomic, retain)NSMutableArray *aTriggerArray;
@property (nonatomic, retain)PreventerWall *theLining;
*/



@property (nonatomic, retain)NSMutableArray *arrayBubbleWasIn;
@property int indexOfArrayBubbleWasIn;
@property (nonatomic, retain)NSTimer *countdownTimer;


/*
 * Methods For The Sprite Class
 */
-(id)initSharedVariable : (Fish *) passedFish : (PreventerWall *) passedPreventerArray : (NSMutableArray *) passedTriggerArray : (NSMutableArray *) passedMiscUpdater;
-(void) updateMe;
-(void)	move;
-(void) chooseTarget;
-(void) chooseLining;
-(void) takeDamage;
-(void) checkCollisionWithFish;

-(BOOL) decrementKillTimer;
-(int) getScore;
-(void) updateScore;
-(void) resetScore;

- (void) spriteDied : (BOOL)updateScore;
-(void) killPreventerBubble;

-(float) distFrom:(CGPoint)p1 to:(CGPoint)p2;
-(bool) isInShape:(CGPoint)p;
-(CGPoint) pointOnCircleFromPoint:(CGPoint)p;

-(void)flashSprite;
-(void)countdown;
-(void)addToView: (Sprite *) aSprite;
-(BOOL)FishCollide;
-(void)spawnSmokeDrop;




@end