//
//  Sprite.m
//  Fish
//
//  Created by Benjamin Squires on 6/09/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Sprite.h"
#import "Fish.h"
#import "Pollen.h"
#import "DustMite.h"
#import "Cold.h"
#import "AnimalFur.h"
#import "Smoke.h"
#import "FluVirus.h"

#import "DeathSplat.h"
#import "ScoreImage.h"
#import "SmokeDrop.h"
#import "SpitProjectile.h"

#import <stdlib.h>
#import <math.h>
#import "PreventerWall.h"
#import "PreventerBubble.h"
#import "FishViewController.h"
#import "RelieverPowerup.h"
#import "PreventerPowerup.h"

#import "Sounds.h"



@implementation Sprite

/*
 *	Sythesize This Sprites Properites
 */
@synthesize XPos;
@synthesize YPos;
@synthesize targetX;
@synthesize targetY;
@synthesize speed;
@synthesize direction;
@synthesize health;
//@synthesize theLining;
//@synthesize aFish;
//@synthesize aTriggerArray;
//@synthesize index;
@synthesize isAttacking;
@synthesize arrayBubbleWasIn;
@synthesize indexOfArrayBubbleWasIn;
@synthesize countdownTimer;
@synthesize isFleeing;
@synthesize ignoreAvoidance;
/*
 *	Variables Shared by all Sprites
 */
float screen_width = 768;
float screen_height = 1002;
int theScore = 0;
int lastTriggerKilled = 0;
int lastKillCount = 0;

PreventerWall *theLining;
Fish *aFish;
NSMutableArray *aTriggerArray;
NSMutableArray *miscUpdaterArray;
Sounds *aSound;


-(id)initSharedVariable : (Fish *) passedFish : (PreventerWall *) passedPreventerArray : (NSMutableArray *) passedTriggerArray : (NSMutableArray *) passedMiscUpdater{
	
	if (self) {
		theLining = passedPreventerArray;
		aFish = passedFish;
		aTriggerArray = passedTriggerArray;
		miscUpdaterArray = passedMiscUpdater;
		lastTriggerKilled = 0;
		lastKillCount = 0;
		theScore = 0;
		aSound = [[Sounds alloc] init];
	}
	return self;
}

/*
 *	The Method Called By the Global gameTimer(NSTimer in GameViewController)
 */
-(void) updateMe{
	[self move];	
	
	[self checkCollisionWithFish];
	
}





- (void) killPreventerBubble {
	//Sprite has Finished Attacking
	isAttacking = FALSE;
	
	
	
	//Reduce Bubble Health
	if ([self isKindOfClass:[Cold class]] || [self isKindOfClass:[Smoke class]]) {
		
		
		//Check to see if first or last in array (Stop out of bounds errors)
		int i = indexOfArrayBubbleWasIn -1;
		int j = indexOfArrayBubbleWasIn + 1;
		if (indexOfArrayBubbleWasIn == 0) {
			i = indexOfArrayBubbleWasIn;
		}
		if (indexOfArrayBubbleWasIn == 38) {
			i = indexOfArrayBubbleWasIn;
		}
		if (indexOfArrayBubbleWasIn == 37) {
			j = indexOfArrayBubbleWasIn;
		}
		if (indexOfArrayBubbleWasIn == 75) {
			j = indexOfArrayBubbleWasIn;
		}		
		
		for (int k = i; k <= j; k++) {
			arrayBubbleWasIn = [theLining objectAtIndex:k];
			PreventerBubble *aBubble = [arrayBubbleWasIn lastObject];
			
			if ([self isKindOfClass:[Cold class]]) {
				[aBubble turnBlueOrBlack : miscUpdaterArray: 0];
				[aSound PlayFrozen];
			}
			else {
				[aBubble turnBlueOrBlack : miscUpdaterArray : 1];
				[aSound PlayBurn];
			}

			
			if ([arrayBubbleWasIn count] == 1) {
				RelieverPowerup *aReliever = [[RelieverPowerup alloc] init:(arc4random() % 400 + 200 ):(arc4random() % 300 + 300) : aFish : aTriggerArray : miscUpdaterArray];
				[aReliever release];
			}
		}
		
	}
	else {
		PreventerBubble *aBubble = [arrayBubbleWasIn lastObject];
		[aBubble turnRed];
		
		[aBubble takeDamage];
		if (aBubble.Health != 0) {
			[aSound PlayBounce:arc4random() % 4];
		}
		else {
			[aSound PlayDestroyBubble];
		}

		
		
		if ([aBubble checkHealth]){
			RelieverPowerup *aReliever = [[RelieverPowerup alloc] init : arc4random() % 400 + 200 : arc4random() % 300 + 300 : aFish : aTriggerArray : miscUpdaterArray ];
			[aReliever release];
		}

		
		
		//set these variables to null to stop illegal updates
		//tempBubble = NULL;
		//arrayBubbleWasIn = NULL;
		
		
		//Make the sprite go back to somewhere in the middle of the 
		//screen so we don't have it travelling inside the preventer lining
		targetX = screen_width/2;
		targetY = arc4random() % 500 + 150;
		
	}
}


/*
 *	Method to Check whether This Sprite has reached its Target
 */
- (void) checkTargetReached {
	
	float dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(targetX, targetY)];
	//if the trigger has almost reached its target choose a new one
	if (dist < 200 && isAttacking == TRUE) {
		radialWidthSprite = 700;
	}
	if (dist < 30) {
		
		if (isAttacking == TRUE) {//If this sprite is attacking do...
			
			[self killPreventerBubble];
			
		}
		else {//this sprite was not attacking so do...
			if (ignoreAvoidance) {
				ignoreAvoidance = FALSE;				
			}
			
			//the chance that this sprite will decide to attack
			int chanceOfAttack = arc4random() % 40;
			
			if (chanceOfAttack > 20) {//if the chance of attack was greater then half dont attack but do...
				[self chooseTarget];
				//printf("happend\n");
				
			}
			else {//chance of attack was good so ATTACK!...
				
				[self chooseLining];
			}
			
		}
	}
	
}


/*
 *	A Method called by the subclass Pollen to move it away from the Fish
 */
- (void) calculateFishAvoidance : (float) springStrength {
	float restingDistance;
	if (isFleeing == TRUE) {
		restingDistance = 200;
		springStrength = 0.09f;
	}
	else {
		restingDistance = 300;
	}
	
	float dxFish =  aFish.XPos - XPos;
	float dyFish =  aFish.YPos - YPos;	
	float distance = sqrtf(dxFish*dxFish + dyFish*dyFish);
	
	//the amount of avoidance starts at zero
	float ddx = 0;
	float ddy = 0;
	
	if(distance < restingDistance)//if the distance between the Fish and the Pollen is less then the Avoidance Spring dictates its time to avoid the fish do...
	{
		//change the amount of avoidance dependent on the relation with the Fish
		ddx = springStrength*(distance-restingDistance)*(dxFish/distance);
		ddy = springStrength*(distance-restingDistance)*(dyFish/distance);
	}		
	else{
		isFleeing = FALSE;
	}
	
	
	//adds the avoidance to the current position
	XPos += ddx;
	YPos += ddy;
	
	CGPoint p = CGPointMake(XPos, YPos);
	bool ins = [self isInShape:p];
	
	if (YPos > 1004 && ins) {
		YPos = 1004;
	}
	else if (YPos < 100 && ins){
		YPos = 100;
	}
	else {
		
		CGPoint p = CGPointMake(XPos, YPos);
		
		if ([self isInShape: p] == FALSE) {
			CGPoint aPoint = [self pointOnCircleFromPoint:p];
			
			YPos = aPoint.y;
			XPos = aPoint.x;
		}
		
	}
	
}


/*
 *	The Method that makes the Sprite move around the Screen
 */
-(void) move{
	
	
	//Works out the direction to head to get to the target
	float dxTarget = XPos - targetX;
	float dyTarget = YPos - targetY;	
	direction = atan2(dyTarget, dxTarget);
	
	//works out the speed to apply for the given direction
	XPos -= speed * cos(direction);
	YPos -= speed * sin(direction);
	
	
	//works out the distance between the Fish and the trigger
	
	if (ignoreAvoidance == FALSE) {
		if ([self isKindOfClass:[Pollen class]] || isFleeing == TRUE) {// If this Sprite is of Type Pollen do this...
			//float k = .05;					//strength of the avoidance spring
			//float restingDistance = 300;	//distance the spring starts to take effect
			
			[self calculateFishAvoidance : .05f];
		}
	}
	
	//Check if Sprite has reached its target
	[self checkTargetReached];
	
	
	//draws the result to the screen
	[self setCenter:CGPointMake(XPos, YPos)];
}


/*
 *	The Method to choose a random posistion on the screen
 */
-(void) chooseTarget{
	
	targetX = arc4random() % 468 + 150;
	targetY = arc4random() % 704 + 150;
	
	//for pollen
	radialWidthSprite = 550;
}

/*
 *	The Method to choose a Random bubble in the preventer Wall
 */
-(void) chooseLining{
	
	//---------------------------------This is the random index in the preventer array to use,  !WARNING!-- This currently uses a hard coded varible. if the bubble size changes so must this
	int randomIndex =  arc4random() % 75 ;
	
	//Save this position so it can be accessed later on
	indexOfArrayBubbleWasIn = randomIndex;
	arrayBubbleWasIn = [theLining objectAtIndex:indexOfArrayBubbleWasIn];
	
	//A temp bubble object to perform operations on
	PreventerBubble *tempBubble = [arrayBubbleWasIn lastObject];
	
	
	if (tempBubble.XPos < (screen_width/2)) {//if the bubble is on the left wall do...
		
		//set Target
		targetX = tempBubble.XPos + 45;
	}
	else {//bubble is on the right wall do...
		
		//set target
		targetX = tempBubble.XPos;
		
	}
	
	//set target y. this is the same no matter which side of the wall.	
	targetY = tempBubble.YPos;
	
	//Let Later operations know we are attacking.
	isAttacking = TRUE;
	
}


/*
 *	A Method to reduce the Sprites health
 */
-(void) takeDamage{
	health--;
}


- (void) spriteDied : (BOOL)updateScore{
	if (updateScore) {
		[self updateScore];
	}
	
	if ([self isKindOfClass:[SmokeDrop class]]) {
		DeathSplat *aSplat = [[DeathSplat alloc] init: self.XPos : self.YPos : miscUpdaterArray : 0];
		[self.superview addSubview:aSplat];
		[self.superview sendSubviewToBack:aSplat];
		[aSplat release];
	}
	else if([self isKindOfClass:[SpitProjectile class]]){
		DeathSplat *aSplat = [[DeathSplat alloc] init: self.XPos : self.YPos : miscUpdaterArray : 1];
		[self.superview addSubview:aSplat];
		[self.superview sendSubviewToBack:aSplat];
		[aSplat release];
	}
	else {		
		//Draw a Splat Image on screen to represent This Sprites Destruction
		DeathSplat *aSplat = [[DeathSplat alloc] init: XPos : YPos : miscUpdaterArray : 2];
		[self.superview addSubview:aSplat];
		[self.superview sendSubviewToBack:aSplat];
		[aSplat release];
	}
	//remove this Sprite from the screen
	[self removeFromSuperview];
	
	
	
	
	
	
	//Remove this sprite from the global update Array. Syncronized to stop concurrent operation errors
	[aTriggerArray removeObject:self];	
	
	
	
	
}

-(void) spawnSmokeDrop{
	SmokeDrop *smokeDrop = [[SmokeDrop alloc] init: XPos : YPos : miscUpdaterArray];
	[self.superview addSubview:smokeDrop];
	[self.superview sendSubviewToBack:smokeDrop];
	[smokeDrop release];
}


- (BOOL) FishCollide {	
	float dist = [self distFrom:CGPointMake(XPos, YPos) to:CGPointMake(aFish.XPos, aFish.YPos)];
	if(dist < 76.5){
		//make the Fish react
		
		[aFish hit : ignoreAvoidance];
	
		if ([self isKindOfClass:[SmokeDrop class]]) {
			return TRUE;
		}
		
		//Reduce Sprite Health
		[self takeDamage];
		isFleeing = TRUE;		
		
		if (self.health == 0) {//If health has reached Zero its time to die so do...
			[self spriteDied:TRUE];
			
			
		}
		else {// Did not die, do...
			
			[self flashSprite];
			
			isAttacking = FALSE;
			//[self chooseTarget];
		}
		return TRUE;
		
		
	}
	return FALSE;
}




/*
 *	A Method to check Whether this sprite has hit the fish
 */
-(void) checkCollisionWithFish{
	
	[self FishCollide];	
	
}




/*
 *	A Method to access the score Globally
 */
-(int) getScore{
	return theScore;
}

-(BOOL) decrementKillTimer{
	if (lastKillCount > 0) {
		lastKillCount --;
		return TRUE;
	}
	return FALSE;
}

-(void) updateScore{
	int multiplier = 1;
	int calculatedScore = 0;
	
	if (![self isKindOfClass:[SmokeDrop class]]) {
	
	if (lastKillCount > 0) {
		multiplier = 2;
	}
	
	// Animal Fur Scoring
	if ([self isKindOfClass:[AnimalFur class]]) {
		if (lastTriggerKilled == 1 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath1];
		lastTriggerKilled = 1;
		calculatedScore = (30 * multiplier);
		theScore += calculatedScore;
	}
	
	// Cold Scoring
	if ([self isKindOfClass:[Cold class]]) {
		if (lastTriggerKilled == 2 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath2];
		lastTriggerKilled = 2;
		calculatedScore = (40 * multiplier);
		theScore += calculatedScore;
	}
	
	// DustMite Scoring
	if ([self isKindOfClass:[DustMite class]]) {
		if (lastTriggerKilled == 3 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath3];
		lastTriggerKilled = 3;
		calculatedScore = (10 * multiplier);
		theScore += calculatedScore;
	}
	
	
	// FluVirus Scoring
	if ([self isKindOfClass:[FluVirus class]]) {
		if (lastTriggerKilled == 4 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath4];
		lastTriggerKilled = 4;
		calculatedScore = (20 * multiplier);
		theScore += calculatedScore;
	}
	
	
	// Pollen Scoring
	if ([self isKindOfClass:[Pollen class]]) {
		if (lastTriggerKilled == 5 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath5];
		lastTriggerKilled = 5;
		calculatedScore = (30 * multiplier);
		theScore += calculatedScore;
	}
	
	
	// Smoke Scoring
	if ([self isKindOfClass:[Smoke class]]) {
		if (lastTriggerKilled == 6 && lastKillCount > 0) {//same kind check
			multiplier = 3;
		}
		[aSound PlayDeath6];
		lastTriggerKilled = 6;
		calculatedScore = (50 * multiplier);
		theScore += calculatedScore;
		
	}
	
	if (multiplier == 3) {
		ScoreImage *twoKindImg = [[ScoreImage alloc] initTwoKind:XPos :YPos :miscUpdaterArray];
		[self.superview addSubview:twoKindImg];
	}
	
	ScoreImage *scoreImage = [[ScoreImage alloc] init:XPos :YPos :miscUpdaterArray : calculatedScore];
	ScoreImage *comboImage = [[ScoreImage alloc] initCombo:XPos :YPos :miscUpdaterArray :multiplier];
	[self.superview addSubview:comboImage];
	[self.superview addSubview:scoreImage];
	
	lastKillCount = 100;
	
	}
	
	
	// Smoke Drop Scoring ------------- NEGATIVE EFFECT
	else {
		calculatedScore = -100;
		theScore += calculatedScore;
		lastKillCount = 0;
		lastTriggerKilled =0;
		ScoreImage *scoreImage = [[ScoreImage alloc] init: XPos :YPos : miscUpdaterArray : calculatedScore];
		[self.superview addSubview:scoreImage];		
	}
	
	
}

-(void) resetScore{
	theScore = 0;
	lastTriggerKilled = 0;
}

//p is from zero zero in the top left 
-(bool) isInShape:(CGPoint)p
{
	p.x -= 768/2;
	p.y -= radialHeightSprite/2;
	
	CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
	CGAffineTransform back = CGAffineTransformInvert(t);
	p = CGPointApplyAffineTransform(p, back);
	p.x += 768/2;
	p.y += radialHeightSprite/2;
	
	float dist = [self distFrom:CGPointMake(768/2, 1004/2) to:p];
	
	if (dist < radialWidthSprite)  {
		return true;
	} 
	return false;
}

//p is from zero zero in the top left 
-(CGPoint) pointOnCircleFromPoint:(CGPoint)p
{
	//move out of screen space.
	p.x -= 768/2;
	p.y -= radialHeightSprite/2;
	CGAffineTransform t = CGAffineTransformMakeScale(.5, 1);
	CGAffineTransform back = CGAffineTransformInvert(t);
	//apply anti scale
	p = CGPointApplyAffineTransform(p, back);
	p.x += 768/2;
	p.y += radialHeightSprite/2; 
	
	//get normal vector
	CGPoint pp = CGPointMake(768/2, 1004/2);
	float dx = p.x - pp.x;
	float dy = p.y  - pp.y;
	float dist = sqrtf(dx*dx + dy *dy);
	dx = dx/dist;
	dy = dy/dist;
	dx *= radialWidthSprite * .5;
	dy *= radialWidthSprite;
	
	//printf("%f\n", dy);
	
	pp.x += dx;
	pp.y += dy;
	return pp;
}



-(float) distFrom:(CGPoint)p1 to:(CGPoint)p2
{
	float dx = p1.x - p2.x;
	float dy = p1.y - p2.y;
	return sqrtf(dx*dx + dy*dy);
}

-(void) flashSprite{
	counter = 6;
	countdownTimer = [NSTimer scheduledTimerWithTimeInterval:1/5.0 target:self selector:@selector(countdown) userInfo:nil repeats:true];
	float currentAlpha = self.alpha;	
	[self setAlpha: currentAlpha - .50];
}

-(void)countdown{
	counter--;
	if (counter == 0) {
		[countdownTimer invalidate];
		[self setAlpha: 1];
		return;
	}
	if(counter % 2 == 0) {	
		[self setAlpha: self.alpha - .50];
	}
	else{
		[self setAlpha: self.alpha + .50];
	}
}

-(void)addToView: (Sprite *) aSprite{
	[aFish.superview addSubview: aSprite];
	[aFish.superview bringSubviewToFront:aSprite];
	[aTriggerArray addObject: aSprite];
}



@end
